
#pragma rtGlobals=1
#pragma version=6.01
#pragma IgorVersion=6		// requires Igor 6 (StatsMedian)

// ********************************************
//  GroupDelay
//  Calculates group delay by taking derivative of S-parameter phase wave with respect to frequency
//  Output wave is the same name as the original phase wave, but with GD appended to the end
// ********************************************

Menu "Analysis"
	"GroupDelay", GroupDelay() // adds button under Analysis menu
End

Function GroupDelay()


variable i=0 //in use
variable j=0 // in use 
variable k=0 // in use
variable m=0 // in use
variable n=0 // in use
variable pnts=0 // in use
variable a=1 // in use
string title=""
string freqwave=""

// this loop starts at the top of the root directory and cycles down the list of wave until a null pointer is reached for
// a wave name, at the end of the loop, the number of waves in root directory is stored in k
do
	wave Sname=WaveRefIndexed("",i,4)	 // gets name of of curent wave
	string nameb=NameOfWave(Sname)
		if(cmpstr(nameb,"")==0)
		a=0
		endif
		i+=1
while(a)
k=i // k store the number of waves in the root directory
i=0 // reset count variable

do
	wave Sname=WaveRefIndexed("",i,4)
	string name=NameOfWave(Sname)

	if (cmpstr(name[strlen(name)-2]+name[strlen(name)-1],"_A")==0)
		freqwave="" // resets freqwave
		
		variable q=0
		string temp=""
		do
		temp[q]=name[q]
		q+=1
		while(q<strlen(name)-1)
	
		title=temp+"GD" //orginal entire wave name, to be used to pull off first 14 characters and then append the correct prefix
		
			
		
Duplicate/O $name,$title
wave w1=$title //create temp wave containing phase data to be manipulated

		// - search through waves in root directory until phase wave are found, then perform group delay computation on phase waves
		// - two separate matches can be phase, due to the naming conventions "wavename_A" for single-ended, and "wavenamed_A"
		// for differential ended wave
		if (cmpstr(name[strlen(name)-2]+name[strlen(name)-1],"_A")==0)
			do 
			freqwave[j]=name[j] // builds wave name of required original frequency wave
			j+=1
			while(j<(strlen(name)-7))
			j=0
//			freqwave=freqwave+"freq_Hz"
			freqwave=WaveName("",0,4) // modified by Alice Tsui
		endif
		wave freq=$freqwave


		do
		// perform point-wise differentiation
		// removes points where phase transition from -180 to +180 occurs and vice versa
			if((w1[n]-w1[n+1])<-100)
				w1[n]=w1[n-1]
			elseif((w1[n]-w1[n+1])>100)
				w1[n]=w1[n-1]
			else
				w1[n] = -(w1[n]-w1[n+1] )/ (360* (freq[n] -freq[n+1]))
			endif
				n+=1
		while(n<numpnts($freqwave))
	n=0
	m=0

	endif

	i+=1
while(i<k)
End


