#pragma rtGlobals=1		// Use modern global access method.
 //*********************************
 //*	 Add_Limit_Line
 //* 	Macro allows user to choose limit line file to be applied to current graph
 //*	Readjusts freq axis to that of the limit line
 //*	Run Format plots afterward to make nice plots : )
 //*
//********************************* 
//adds button to macros menu
Menu "Macros"
	"Add_Limit_Line", limitlines() 
End

Function limitlines()
// Open window to allow user to select limit line file
	Variable refNum
	variable pnts
	variable maxfreq
	variable i=1
	variable j=0
	variable k=0
	variable m=0
	variable n=0
	variable test
	variable flag=0
	variable flag2=1
	string freqname=""
	string traces=""
	variable lim_pnts=0
	String message = "Select a limit line file"
	String outputPath
	String freq=""
	String filename=""
	String fileFilters = "Data Files (*.txt,*.dat,*.csv):.txt,.dat,.csv;"
	fileFilters += "All Files:.*;"

String check_type
Prompt check_type, "Select the limit line type:", popup, ("Insertion Loss;Return Loss;Near-end crosstalk;Far-end crosstalk")
DoPrompt "Limit Line", check_type
	if (V_flag)
		return NaN
	endif

// Opens dialog box so user can choose limit line file
	Open /D /R /F=fileFilters /M=message refNum
	outputPath = S_fileName
	if(cmpstr(outputPath,"")==0)
	return 0
	endif
	
//Pulls filename off of path to limit line file so that we can name the freq & mag waves	
	do
	i+=1
	while(cmpstr(outputPath[strlen(outputPath)-i],":")!=0)
	i-=1
	do
	freq[j]=outputPath[strlen(outputPath)-i]
	j+=1
	i-=1
	while(i-4)
	
// Loads user selected limit line file	
loadwave  /O /A=$freq  /J    outputPath
duplicate /O $freq +"0", $freq+"_freq" //creates unique waves for freq & mag
duplicate /O $freq+"1", $freq+"_magnitude"
killwaves $freq +"0", $freq+"1" // gets rid of original waves made by loadwave

//Plots limit line file on current graph
wave limit_line_freq=$freq+"_freq"
wave limit_line_magnitude= $freq+"_magnitude"

limit_line_freq=limit_line_freq*10e5 // converts MHz to GHz
String graphName = WinName(0, 1)
if (cmpstr(graphName,"")==0)
Display  limit_line_magnitude vs limit_line_freq
else
AppendToGraph limit_line_magnitude vs limit_line_freq
	pnts = numpnts(limit_line_freq) // determines number of data points in limit line file
	maxfreq=limit_line_freq[pnts] // determines max freq of limit line
	SetAxis bottom *,maxfreq // truncates freq axis to that of limit line
Endif

// Gets name of trace and to help decide correct labels for x & y axis	
	traces=tracenamelist("",";",1) // gets string with all traces name, ";" seperated
	i=0
	string traceName=""
	do
	     
		do
		
		traceName[k]=traces[i] // pulls off first trace name
		i+=1
		k+=1
		
		while(cmpstr(traces[i],";"))
		if(n==1)
		traces[i]=""
		endif
		
		k=0
		i+=1
		// enters loop if tracename is not that of limit line
		if (cmpstr(freq+"_magnitude",traceName)!=0)
			wave comp_mag = $tracename // creates traces magnitude wave
			j=0
			// loop creates freq wave with name created from current graph trace name
			do
			freqname[j]=tracename[j]
			j+=1
			
			strswitch(tracename[j+6]+tracename[j+7]+tracename[j+8])
				case "_dB":
					freqname=freqname+"_freq_Hz"
					flag2=0
					break
				
			endswitch

		while(flag2)
			
			wave comp_freq = $freqname
			// find out how many points of trace wave are less than max freq of limit line file
			do
			lim_pnts+=1
			m+=1
			while(comp_freq[m]<limit_line_freq[lim_pnts])
				m=0
				string name = nameofwave(limit_line_magnitude)
				string nameb = nameofwave(limit_line_freq)
				
				Make/O/N=(lim_pnts) xData,yData
				// interpolates limit line file to have same number of points as trace wave
				Interpolate2/T=1/N=(lim_pnts)/X=xData/Y=yData  limit_line_freq,limit_line_magnitude
				duplicate /O xData, limit_line_freq
				duplicate /O yData, limit_line_magnitude
				killwaves xData,yData
				
				// checks to see if pass or fail
				do
					if(cmpstr(check_type,"Insertion Loss")==0)
						if (comp_mag[m] < limit_line_magnitude[m])
						TextBox/C/N=text9/F=0/A=RC "\Zr125Fail"
						flag=1
						m+=1
						endif
						m+=1
					elseif(cmpstr(check_type,"Return Loss")==0)
						if (comp_mag[m] > limit_line_magnitude[m])
						TextBox/C/N=text9/F=0/A=RC "\Zr125Fail"
						flag=1
						m+=1
						endif
						m+=1
					
					elseif(cmpstr(check_type,"Near-end Crosstalk")==0)
						if (comp_mag[m] > limit_line_magnitude[m])
						TextBox/C/N=text9/F=0/A=RC "\Zr125Fail"
						flag=1
						m+=1
						endif
						m+=1
					
					elseif(cmpstr(check_type,"Far-end Crosstalk")==0)
						if (comp_mag[m] > limit_line_magnitude[m])
						TextBox/C/N=text9/F=0/A=RC "\Zr125Fail"
						flag=1
						m+=1
						endif
						m+=1
					else
					endif
				while(m<lim_pnts)
		endif
		tracename=""
while(cmpstr(traces[i],"")!=0)
	if (flag==0)
		TextBox/C/N=text8/F=0/A=RC "\Zr125Pass" //Adds pass to graph if fail didn't occurs
	endif
End

 